<?php
# ComBack for DotClear
# (c)2006-2009 Jihem
#--
# Classe de gestion des 'combacks' (rponses aux commentaires)

class comback
{
	var $con;	# Connexion  la BD
	var $blog;	# Objet blog
	var $table;	# Nom de la table de stockage des combacks

	# Constructeur
	function comback(&$blog)
	{
		$this->con = $blog->con;
		$this->blog = $blog;
		$this->table = $blog->prefix.'comback';
	}

	# Installation : cration de la table si besoin
	function install()
	{
		$strReq = "CREATE TABLE IF NOT EXISTS $this->table (
 comment_id int(11) NOT NULL default '0',
 user_id varchar(32) binary default NULL,
 comback_dt datetime default NULL,
 comback_upddt datetime default NULL,
 comback_content longtext,
 PRIMARY KEY (comment_id)
);";
		if (!$this->con->execute($strReq)) {
			$this->blog->setError('MySQL : '.$this->con->error(), 2000);
			return false;
		}
		return true;
	}
	
	# Vrification des arguments
	function checkArgs($com_id, $user_id, $content)
	{
		if (!$com_id)
			$this->blog->error->add(__('No comment ID'), 1000);
		if (!$user_id)
			$this->blog->error->add(__('No user ID'), 1000);
		if (!$content)
			$this->blog->error->add(__('Empty reply content'), 1000);
		if ($this->blog->error->flag())
			return false;
		return true;
	}
	
	# Ajout d'un nouveau comback
	function addComback($com_id, $user_id, $content)
	{
		# Vrifications
		if (!$this->checkArgs(trim($com_id), trim($user_id), trim($content)))
			return false;
		
		# Insertion
		$insReq = "insert into $this->table
	       			(comment_id, user_id, comback_dt,
			       	comback_upddt, comback_content)
			values ($com_id, '".$this->con->escape($user_id)."',
		       		SYSDATE(), SYSDATE(),
				'".$this->con->escape($content)."')";

		if (!$this->con->execute($insReq)) {
			$this->blog->error->add('MySQL : '.$this->con->error(), 2000);
			return false;
		}
		
		$this->blog->blog->triggerBlog();
		return true;
	}

	# Mise  jour d'un comback existant
	function updComback($com_id, $user_id, $content)
	{
		# Vrifications
		if (!$this->checkArgs(trim($com_id), trim($user_id), trim($content)))
			return false;

		# Mise  jour
		$updReq = "update $this->table set
				user_id = '".$this->con->escape($user_id)."',
				comback_upddt = SYSDATE(),
				comback_content = '".$this->con->escape($content)."'
			where comment_id = $com_id";

		if (!$this->con->execute($updReq)) {
			$this->blog->error->add('MySQL : '.$this->con->error(), 2000);
			return false;
		}
		
		$this->blog->blog->triggerBlog();
		return true;
	}

	# Suppression d'un comback
	function delComback($com_id)
	{
		$strReq = "select comment_id from $this->table where comment_id = $com_id";
		
		$rs = $this->con->select($strReq);
		if ($rs == false) {
			$this->blog->error->add('MySQL : '.$this->con->error(), 2000);
			return false;
		}
		if ($rs->isEmpty())
			return false;

		$delReq = "delete from $this->table where comment_id = $com_id";
		if (!$this->con->execute($delReq)) {
			$this->blog->error->add('MySQL : '.$this->con->error(), 2000);
			return false;
		}

		$this->blog->blog->triggerBlog();
		return true;
	}
	
	# Mise  jour si le comback existe, cration sinon, suppression si le contenu est vide
	function saveComback($com_id, $user_id, $content)
	{
		$strReq = "select comment_id from $this->table where comment_id = $com_id";

		$rs = $this->con->select($strReq);
		if ($rs == false) {
			$this->blog->error->add('MySQL : '.$this->con->error(), 2000);
			return false;
		}

		if ($rs->isEmpty()) {
			if (!trim($content))
				return true;

			return $this->addComback($com_id, $user_id, $content);
		}
		
		if (!trim($content))
			return $this->delComback($com_id);
	
		return $this->updComback($com_id, $user_id, $content);
	}
	
	# Rcupration du contenu d'un comback
	function getComback($com_id)
	{
		$strReq = "select cb.comment_id, cb.user_id,
	       			u.user_displayname user_pseudo, u.user_firstname user_prenom, u.user_name user_nom,
				cb.comback_dt, cb.comback_upddt, cb.comback_content
			from $this->table cb, {$this->blog->prefix}user u
			where cb.comment_id = $com_id and cb.user_id = u.user_id";

		$rs = $this->con->select($strReq);
		if ($rs == false) {
			$this->blog->error->add('MySQL : '.$this->con->error(), 2000);
			return false;
		}
		if ($rs->isEmpty())
			return false;

		return $rs;
	}
}
?>
